###################################################
### chunk number 1: 
###################################################
options(scipen=3, digits=4, prompt="R> ", eps=FALSE, width=75)
### for sampling
set.seed(1234)


###################################################
### chunk number 2: 
###################################################
library("recommenderlab")
data(MSWeb)

MSWeb5 <- MSWeb[rowCounts(MSWeb) >5,]
MSWeb5


###################################################
### chunk number 3: rowCounts
###################################################
hist(rowCounts(MSWeb5), breaks=20)


###################################################
### chunk number 4: 
###################################################
LIST(MSWeb5[1:2])


###################################################
### chunk number 5:  eval=FALSE
###################################################
## image(sample(MSWeb5, 200))


###################################################
### chunk number 6: image
###################################################
plot(image(sample(MSWeb5, 200)))


###################################################
### chunk number 7: colCounts
###################################################
hist(colCounts(MSWeb5), breaks=25)


###################################################
### chunk number 8: 
###################################################
r <- Recommender(MSWeb5[1:1000], method = "POPULAR")
r


###################################################
### chunk number 9: 
###################################################
getModel(r)


###################################################
### chunk number 10: 
###################################################
recom <- predict(r, MSWeb5[1001:1002], n=5)
recom


###################################################
### chunk number 11: 
###################################################
LIST(recom)


###################################################
### chunk number 12: 
###################################################
recom3 <- bestN(recom, n = 3)
recom3
LIST(recom3)


###################################################
### chunk number 13: 
###################################################
scheme <- evaluationScheme(MSWeb5, method="cross", k=4, given=3)
scheme


###################################################
### chunk number 14: 
###################################################
results <- evaluate(scheme, method="POPULAR", n=c(1,3,5,10,15,20))
results


###################################################
### chunk number 15: 
###################################################
getConfusionMatrix(results)[[1]]


###################################################
### chunk number 16: 
###################################################
avg(results)


###################################################
### chunk number 17: roc1
###################################################
plot(results, annotate=TRUE)


###################################################
### chunk number 18: precrec1
###################################################
plot(results, "prec/rec", annotate=TRUE)


###################################################
### chunk number 19: 
###################################################
load("xresults.rda")


###################################################
### chunk number 20:  eval=FALSE
###################################################
## ## this needs to be saved to disk! see run_recommender.R
## algorithms <- list(
##         "random items" = list(name="RANDOM", param=NULL),
##         "popular items" = list(name="POPULAR", param=NULL),
##         "user-based CF" = list(name="UBCF", param=list(method="Jaccard", nn=50)),
##         "item-based CF" = list(name="IBCF", param=list(method="Jaccard", k=50)),
##         "association rules" = list(name="AR", param=list(supp=0.001, conf=0.2, maxlen=2))
##         )
## 
## ## run algorithms
## results <- evaluate(scheme, algorithms, n=c(1, 3, 5, 10, 15, 20))
## ## save(results, file="xresults.rda")


###################################################
### chunk number 21: 
###################################################
results


###################################################
### chunk number 22: 
###################################################
names(results)
results[["association rules"]]


###################################################
### chunk number 23: roc2
###################################################
plot(results, annotate=c(1,3), legend="right")


###################################################
### chunk number 24: precrec2
###################################################
plot(results, "prec/rec", annotate=3)


###################################################
### chunk number 25: 
###################################################
scheme1 <- evaluationScheme(MSWeb5, method="cross", k=4, given=1)
scheme1


###################################################
### chunk number 26:  eval=FALSE
###################################################
## results1 <- evaluate(scheme1, algorithms, n=c(1,3,5,10,15,20))
## ## save(results1, file="xresults1.rda")


###################################################
### chunk number 27: 
###################################################
load("xresults1.rda")


###################################################
### chunk number 28: roc3
###################################################
plot(results1, annotate=c(1,3), legend="right")


